//===-- Skeleton.h - Target private header file -----------------*- C++ -*-===//
//
//                     The LLVM Compiler Infrastructure
//
// This file was developed by the LLVM research group and is distributed under
// the University of Illinois Open Source License. See LICENSE.TXT for details.
//
//===----------------------------------------------------------------------===//
//
// This file contains the definitions shared among the various components of the
// Skeleton backend.
//
//===----------------------------------------------------------------------===//

#ifndef TARGET_SKELETON_H
#define TARGET_SKELETON_H

#include <iosfwd>

/// Put prototypes here for functions used to create various passes.


// Defines symbolic enum names for target registers.  This defines a mapping
// from register name to register number.  These are generated by tblgen from
// your target file.
//
#include "SkeletonGenRegisterNames.inc"

// Defines symbolic enum names for the target instructions.
//
#include "SkeletonGenInstrNames.inc"

#endif
